<template>
  <div class="calendar" v-on:mousedown="onMouseDown" v-on:mouseup="onMouseUp">
    <div class="calendar_grid">
      <div
        class="calendar_header"
        v-for="dayOfWeek in daysOfWeek"
        :key="dayOfWeek"
      >
        {{ dayOfWeek }}
      </div>
      <div
        v-for="n in blankStart"
        :key="n"
        class="calendar_cell calendar-cell_empty"
      ></div>
      <CalendarCell
        v-for="day in daysList"
        :key="day.unix()"
        v-bind:day="day"
        v-bind:selectedDayOfWeek="getSelectedDayOfWeek"
        v-bind:isMouseDown="mouseDown"
        @addSelectedDay="addSelectedDay"
        @deleteSelectedDay="deleteSelectedDay"
      />
      <div
        v-for="n in blankEnd"
        :key="n + 7"
        class="calendar_cell calendar-cell_empty"
      ></div>
    </div>
    <SelectedDaysViewer v-bind:selectedDays="selectedDays" />
  </div>
</template>

<script>
import moment from "moment";
import CalendarCell from "./CalendarCell.vue";
import SelectedDaysViewer from "./SelectedDaysViewer.vue";
export default {
  name: "Calendar",
  components: {
    CalendarCell,
    SelectedDaysViewer
  },
  props: {
    month: { type: Object },
    selectedDayOfweek: { type: Object }
  },
  computed: {
    daysList() {
      return this.getDaysList(this.month?.month, this.month?.year);
    },
    blankStart() {
      return this.daysList[0] ? this.daysList[0].weekday() : 0;
    },
    blankEnd() {
      return this.daysList.length > 0
        ? 6 - this.daysList[this.daysList.length - 1].weekday()
        : 0;
    },
    getSelectedDayOfWeek() {
      return this.selectedDayOfweek;
    }
  },
  data() {
    return {
      mouseDown: false,
      selectedDays: [],
      daysOfWeek: [
        "Sunday",
        "Monday",
        "Tuesday",
        "Wednesday",
        "Thursday",
        "Friday",
        "Saturday"
      ]
    };
  },
  methods: {
    getDaysList(month, year) {
      this.selectedDays = [];
      const daysList = [];
      let currentDate = moment(new Date(year, month, 1));
      while (currentDate.month() === month) {
        daysList.push(currentDate.clone());
        currentDate = currentDate.add(1, "d");
      }
      return daysList;
    },
    onMouseDown() {
      this.mouseDown = true;
    },
    onMouseUp() {
      this.mouseDown = false;
    },
    addSelectedDay(day) {
      this.selectedDays.push(day);
      this.selectedDays = [...this.selectedDays];
    },
    deleteSelectedDay(day) {
      this.selectedDays.splice(this.selectedDays.indexOf(day), 1);
      this.selectedDays = [...this.selectedDays];
    }
  }
};
</script>
<style>
.calendar {
  display: grid;
  width: 100%;
  grid-template-columns: 84% 15%;
  grid-gap: 1%;
}
.calendar_grid {
  width: 100%;
  display: grid;
  grid-template-columns: repeat(7, 1fr);
  border: 1px solid black;
}
.calendar_cell {
  text-align: left;
  border: 1px solid black;
  padding: 10px;
  user-select: none;
  min-height: 100px;
}
.calendar-cell_empty {
  background-color: lightgrey;
}
.calendar_header {
  border: 1px solid black;
  padding: 5px;
}
</style>
